diff -ur inkscape-20040527/src/display/bezier-utils.cpp inkscape-20040527_patched/src/display/bezier-utils.cpp
--- inkscape-20040527/src/display/bezier-utils.cpp	Fri May 28 13:45:10 2004
+++ inkscape-20040527_patched/src/display/bezier-utils.cpp	Tue Jun  8 14:15:59 2004
@@ -25,6 +25,7 @@
 #define noBEZIER_DEBUG
 
 #include <math.h>
+#include <ieeefp.h>
 #include <stdlib.h>
 #include "bezier-utils.h"
 #include <libnr/nr-point-fns.h>
@@ -444,7 +445,7 @@
         }
     }
 
-    if (!isfinite(improved_u)) {
+    if (!finite(improved_u)) {
         improved_u = u;
     } else if ( improved_u < 0.0 ) {
         improved_u = 0.0;
@@ -606,7 +607,7 @@
     /* Then scale to [0.0 .. 1.0]. */
     gdouble tot_len = u[len - 1];
     g_return_if_fail( tot_len != 0 );
-    if (isfinite(tot_len)) {
+    if (finite(tot_len)) {
         for (unsigned i = 1; i < len; ++i) {
             u[i] /= tot_len;
         }
diff -ur inkscape-20040527/src/display/canvas-bpath.cpp inkscape-20040527_patched/src/display/canvas-bpath.cpp
--- inkscape-20040527/src/display/canvas-bpath.cpp	Fri May 28 13:45:10 2004
+++ inkscape-20040527_patched/src/display/canvas-bpath.cpp	Tue Jun  8 14:17:25 2004
@@ -348,7 +348,7 @@
     uint8_t*   d=(uint8_t*)dest.buffer;
 
     d+=3*(st-dest.startPix);
-    if ( fabsf(dv) < 0.001 ) {
+    if ( fabs(dv) < 0.001 ) {
 	if ( sv > 249.999 ) {
 	    /* Simple copy */
 	    while (len > 0) {
@@ -407,10 +407,10 @@
     theS->CalcBBox();
     float  l=theS->leftX,r=theS->rightX,t=theS->topY,b=theS->bottomY;
     int    il,ir,it,ib;
-    il=(int)floorf(l);
-    ir=(int)ceilf(r);
-    it=(int)floorf(t);
-    ib=(int)ceilf(b);
+    il=(int)floor(l);
+    ir=(int)ceil(r);
+    it=(int)floor(t);
+    ib=(int)ceil(b);
 
     if ( il >= area.x1 || ir <= area.x0 || it >= area.y1 || ib <= area.y0 ) return;
     if ( il < area.x0 ) il=area.x0;
diff -ur inkscape-20040527/src/display/nr-arena-shape.cpp inkscape-20040527_patched/src/display/nr-arena-shape.cpp
--- inkscape-20040527/src/display/nr-arena-shape.cpp	Fri May 28 13:45:10 2004
+++ inkscape-20040527_patched/src/display/nr-arena-shape.cpp	Tue Jun  8 14:07:42 2004
@@ -271,7 +271,7 @@
 	    float width, scale;
 	    scale = NR_MATRIX_DF_EXPANSION (&gc->transform);
 	    width = MAX (0.125, shape->_stroke.width * scale);
-	    if ( fabsf(shape->_stroke.width * scale) > 0.01 ) { // sinon c'est 0=oon veut pas de bord
+	    if ( fabs(shape->_stroke.width * scale) > 0.01 ) { // sinon c'est 0=oon veut pas de bord
 		bbox.x0-=width;
 		bbox.x1+=width;
 		bbox.y0-=width;
@@ -472,7 +472,7 @@
 
     if (shape->_stroke.paint.type() != NRArenaShape::Paint::NONE) {
 	const float scale = NR_MATRIX_DF_EXPANSION (&gc->transform);
-	if ( fabsf(shape->_stroke.width * scale) > 0.01 ) { // sinon c'est 0=oon veut pas de bord
+	if ( fabs(shape->_stroke.width * scale) > 0.01 ) { // sinon c'est 0=oon veut pas de bord
 	    const float width = MAX (0.125, shape->_stroke.width * scale);
 	    NR::Matrix cached_to_new;
 	    int isometry = 0;
@@ -578,10 +578,10 @@
 {
     if ( shape->stroke_shp ) {
 	shape->stroke_shp->CalcBBox();
-	shape->stroke_shp->leftX=floorf(shape->stroke_shp->leftX);
-	shape->stroke_shp->rightX=ceilf(shape->stroke_shp->rightX);
-	shape->stroke_shp->topY=floorf(shape->stroke_shp->topY);
-	shape->stroke_shp->bottomY=ceilf(shape->stroke_shp->bottomY);
+	shape->stroke_shp->leftX=floor(shape->stroke_shp->leftX);
+	shape->stroke_shp->rightX=ceil(shape->stroke_shp->rightX);
+	shape->stroke_shp->topY=floor(shape->stroke_shp->topY);
+	shape->stroke_shp->bottomY=ceil(shape->stroke_shp->bottomY);
 	if ( bbox.x0 >= bbox.x1 ) {
 	    if ( shape->stroke_shp->leftX < shape->stroke_shp->rightX ) {
 		bbox.x0=shape->stroke_shp->leftX;
@@ -607,10 +607,10 @@
     }
     if ( shape->fill_shp ) {
 	shape->fill_shp->CalcBBox();
-	shape->fill_shp->leftX=floorf(shape->fill_shp->leftX);
-	shape->fill_shp->rightX=ceilf(shape->fill_shp->rightX);
-	shape->fill_shp->topY=floorf(shape->fill_shp->topY);
-	shape->fill_shp->bottomY=ceilf(shape->fill_shp->bottomY);
+	shape->fill_shp->leftX=floor(shape->fill_shp->leftX);
+	shape->fill_shp->rightX=ceil(shape->fill_shp->rightX);
+	shape->fill_shp->topY=floor(shape->fill_shp->topY);
+	shape->fill_shp->bottomY=ceil(shape->fill_shp->bottomY);
 	if ( bbox.x0 >= bbox.x1 ) {
 	    if ( shape->fill_shp->leftX < shape->fill_shp->rightX ) {
 		bbox.x0=shape->fill_shp->leftX;
@@ -1096,7 +1096,7 @@
     int     len=en-st;
     unsigned char*   d=(unsigned char*)dest.buffer;
     d+=(st-dest.startPix);
-    if ( fabsf(dv) < 0.001 ) {
+    if ( fabs(dv) < 0.001 ) {
 	if ( vst > 0.999 ) {
 	    /* Simple copy */
 	    while (len > 0) {
@@ -1156,10 +1156,10 @@
     theS->CalcBBox();
     float  l=theS->leftX,r=theS->rightX,t=theS->topY,b=theS->bottomY;
     int    il,ir,it,ib;
-    il=(int)floorf(l);
-    ir=(int)ceilf(r);
-    it=(int)floorf(t);
-    ib=(int)ceilf(b);
+    il=(int)floor(l);
+    ir=(int)ceil(r);
+    it=(int)floor(t);
+    ib=(int)ceil(b);
 
     if ( il >= m.area.x1 || ir <= m.area.x0 || it >= m.area.y1 || ib <= m.area.y0 ) return;
     if ( il < m.area.x0 ) il=m.area.x0;
diff -ur inkscape-20040527/src/display/sp-canvas.h inkscape-20040527_patched/src/display/sp-canvas.h
--- inkscape-20040527/src/display/sp-canvas.h	Fri May 28 13:45:10 2004
+++ inkscape-20040527_patched/src/display/sp-canvas.h	Mon Jun  7 19:56:11 2004
@@ -25,7 +25,7 @@
 
 #include <helper/helper-forward.h>
 
-#include <stdint.h>
+#include <inttypes.h>
 
 enum {
 	SP_CANVAS_UPDATE_REQUESTED  = 1 << 0,
diff -ur inkscape-20040527/src/display/sp-ctrlline.cpp inkscape-20040527_patched/src/display/sp-ctrlline.cpp
--- inkscape-20040527/src/display/sp-ctrlline.cpp	Fri May 28 13:45:10 2004
+++ inkscape-20040527_patched/src/display/sp-ctrlline.cpp	Tue Jun  8 14:18:17 2004
@@ -250,7 +250,7 @@
     uint8_t*   d=(uint8_t*)dest.buffer;
   
     d+=3*(st-dest.startPix);
-    if ( fabsf(dv) < 0.001 ) {
+    if ( fabs(dv) < 0.001 ) {
         if ( sv > 249.999 ) {
             /* Simple copy */
             while (len > 0) {
@@ -309,10 +309,10 @@
     theS->CalcBBox();
     float  l=theS->leftX,r=theS->rightX,t=theS->topY,b=theS->bottomY;
     int    il,ir,it,ib;
-    il=(int)floorf(l);
-    ir=(int)ceilf(r);
-    it=(int)floorf(t);
-    ib=(int)ceilf(b);
+    il=(int)floor(l);
+    ir=(int)ceil(r);
+    it=(int)floor(t);
+    ib=(int)ceil(b);
   
 //  printf("bbox %i %i %i %i  render %i %i %i %i\n",il,it,ir,ib,area.x0,area.y0,area.x1,area.y1);
   
diff -ur inkscape-20040527/src/libnr/nr-svp.cpp inkscape-20040527_patched/src/libnr/nr-svp.cpp
--- inkscape-20040527/src/libnr/nr-svp.cpp	Fri May 28 13:45:11 2004
+++ inkscape-20040527_patched/src/libnr/nr-svp.cpp	Tue Jun  8 14:20:26 2004
@@ -13,6 +13,7 @@
 
 #define NR_SVP_LENGTH_MAX 128
 
+#include <ieeefp.h>
 #include <assert.h>
 #include <stdio.h>
 #include <glib.h>
diff -ur inkscape-20040527/src/libnrtype/nr-rasterfont.cpp inkscape-20040527_patched/src/libnrtype/nr-rasterfont.cpp
--- inkscape-20040527/src/libnrtype/nr-rasterfont.cpp	Fri May 28 13:45:11 2004
+++ inkscape-20040527_patched/src/libnrtype/nr-rasterfont.cpp	Tue Jun  8 14:21:49 2004
@@ -503,7 +503,7 @@
     int     len=en-st;
     unsigned char*   d=(unsigned char*)dest.buffer;
     d+=(st-dest.startPix);
-    if ( fabsf(dv) < 0.001 ) {
+    if ( fabs(dv) < 0.001 ) {
         if ( vst > 0.999 ) {
             /* Simple copy */
             while (len > 0) {
@@ -564,10 +564,10 @@
     theS->CalcBBox();
     float  l=theS->leftX,r=theS->rightX,t=theS->topY,b=theS->bottomY;
     int    il,ir,it,ib;
-    il=(int)floorf(l);
-    ir=(int)ceilf(r);
-    it=(int)floorf(t);
-    ib=(int)ceilf(b);
+    il=(int)floor(l);
+    ir=(int)ceil(r);
+    it=(int)floor(t);
+    ib=(int)ceil(b);
   
     if ( il >= m.area.x1 || ir <= m.area.x0 || it >= m.area.y1 || ib <= m.area.y0 ) return;
     if ( il < m.area.x0 ) il=m.area.x0;
diff -ur inkscape-20040527/src/libnrtype/nr-type-directory.cpp inkscape-20040527_patched/src/libnrtype/nr-type-directory.cpp
--- inkscape-20040527/src/libnrtype/nr-type-directory.cpp	Fri May 28 13:45:11 2004
+++ inkscape-20040527_patched/src/libnrtype/nr-type-directory.cpp	Tue Jun  8 14:30:25 2004
@@ -291,10 +291,7 @@
 bool
 ink_strstr (const char *haystack, const char *pneedle)
 {
-#ifndef WIN32
-	return (strcasestr(haystack, pneedle) != NULL);
-#else
-	// windows has no strcasestr implementation, so here is ours...
+	// Windows and Solaris have no strcasestr implementation, so here is ours...
 	// stolen from nmap
 	char buf[512];
 	register const char *p;
@@ -316,7 +313,6 @@
 		} else foundto = needle;
 	}
 	return false;
-#endif
 }
 
 // FIXME: make this UTF8, add non-English style names
diff -ur inkscape-20040527/src/libnrtype/nr-type-xft.cpp inkscape-20040527_patched/src/libnrtype/nr-type-xft.cpp
--- inkscape-20040527/src/libnrtype/nr-type-xft.cpp	Fri May 28 13:45:11 2004
+++ inkscape-20040527_patched/src/libnrtype/nr-type-xft.cpp	Mon Jun 14 11:09:33 2004
@@ -13,6 +13,7 @@
 #include <stdio.h>
 
 #include <ft2build.h>
+#include <X11/Xlib.h>
 #include <X11/Xft/Xft.h>
 
 #include <glib.h>
diff -ur inkscape-20040527/src/livarot/AVL.h inkscape-20040527_patched/src/livarot/AVL.h
--- inkscape-20040527/src/livarot/AVL.h	Fri May 28 13:45:09 2004
+++ inkscape-20040527_patched/src/livarot/AVL.h	Mon Jun  7 20:06:54 2004
@@ -11,7 +11,7 @@
 
 #include <stdio.h>
 #include <stdlib.h>
-#include <stdint.h>
+#include <inttypes.h>
 #include <string.h>
 //#include <iostream.h>
 
diff -ur inkscape-20040527/src/livarot/AlphaLigne.cpp inkscape-20040527_patched/src/livarot/AlphaLigne.cpp
--- inkscape-20040527/src/livarot/AlphaLigne.cpp	Fri May 28 13:45:09 2004
+++ inkscape-20040527_patched/src/livarot/AlphaLigne.cpp	Mon Jun 14 11:13:17 2004
@@ -57,8 +57,8 @@
 //	printf("%f %f -> %f %f / %f\n",spos,sval,epos,eval,tPente);
 	if ( sval == eval ) return 0;
   // compute the footprint of [spos,epos] on the line of pixels
-	float  curStF=floorf(spos);
-	float  curEnF=floorf(epos);
+	float  curStF=floor(spos);
+	float  curEnF=floor(epos);
 	int   curSt=(int)curStF;
 	int   curEn=(int)curEnF;
 	
@@ -69,7 +69,7 @@
     return 0;
   }
 	if ( curSt < curMin ) curMin=curSt;
-	if ( ceilf(epos) > curMax ) curMax=(int)ceilf(epos);
+	if ( ceil(epos) > curMax ) curMax=(int)ceil(epos);
 	
   // clamp the changed portion to [min,max], no need for bigger
 	if ( curMax > max ) curMax=max;
@@ -215,8 +215,8 @@
 	// pas de pente dans ce cas; on ajoute le delta au premier pixel
 	float   tPente=(eval-sval);
 
-	float curStF=floorf(spos);
-	float curEnF=floorf(epos);
+	float curStF=floor(spos);
+	float curEnF=floor(epos);
 	int   curSt=(int)curStF;
 	int   curEn=(int)curEnF;
 	
@@ -231,7 +231,7 @@
 	
 	if ( curSt < curMin ) curMin=curSt;
 //	int   curEn=(int)curEnF;
-	if ( ceilf(epos) > curMax-1 ) curMax=1+(int)ceilf(epos);
+	if ( ceil(epos) > curMax-1 ) curMax=1+(int)ceil(epos);
 	if ( curSt < min ) {
 		before.delta+=eval-sval;
 	} else {
diff -ur inkscape-20040527/src/livarot/AlphaLigne.h inkscape-20040527_patched/src/livarot/AlphaLigne.h
--- inkscape-20040527/src/livarot/AlphaLigne.h	Fri May 28 13:45:09 2004
+++ inkscape-20040527_patched/src/livarot/AlphaLigne.h	Tue Jun  8 14:09:19 2004
@@ -12,7 +12,7 @@
 
 #include <stdio.h>
 #include <stdlib.h>
-#include <stdint.h>
+#include <inttypes.h>
 #include <string.h>
 //#include <iostream.h>
 
diff -ur inkscape-20040527/src/livarot/BitLigne.cpp inkscape-20040527_patched/src/livarot/BitLigne.cpp
--- inkscape-20040527/src/livarot/BitLigne.cpp	Fri May 28 13:45:09 2004
+++ inkscape-20040527_patched/src/livarot/BitLigne.cpp	Mon Jun 14 11:13:59 2004
@@ -18,8 +18,8 @@
 	st=ist;
 	en=ien;
 	if ( en <= st ) en=st+1;
-	stBit=(int)floorf(((float)st)*invScale); // round to pixel boundaries in the canvas
-	enBit=(int)ceilf(((float)en)*invScale);
+	stBit=(int)floor(((float)st)*invScale); // round to pixel boundaries in the canvas
+	enBit=(int)ceil(((float)en)*invScale);
 	int  nbBit=enBit-stBit;
 	if ( nbBit&31 ) {
 		nbInt=nbBit/32+1;
@@ -54,15 +54,15 @@
   // the goal is to obtain a set of bits that are "on the edges" of the polygon, so that their coverage
   // will be 1/2 on the average. in practice it's useless for anything but the even-odd fill rule
 	int   ffBit,lfBit; // first and last bit of the portion of the line that is entirely covered
-	ffBit=(int)(ceilf(invScale*spos));
-	lfBit=(int)(floorf(invScale*epos));
+	ffBit=(int)(ceil(invScale*spos));
+	lfBit=(int)(floor(invScale*epos));
 	int   fpBit,lpBit; // first and last bit of the portion of the line that is not entirely but partially covered
-	fpBit=(int)(floorf(invScale*spos));
-	lpBit=(int)(ceilf(invScale*epos));
+	fpBit=(int)(floor(invScale*spos));
+	lpBit=(int)(ceil(invScale*epos));
   
   // update curMin and curMax to reflect the start and end pixel that need to be updated on the canvas
-	if ( floorf(spos) < curMin ) curMin=(int)floorf(spos);
-	if ( ceilf(epos) > curMax ) curMax=(int)ceilf(epos);
+	if ( floor(spos) < curMin ) curMin=(int)floor(spos);
+	if ( ceil(epos) > curMax ) curMax=(int)ceil(epos);
 
   // clamp to the line
 	if ( ffBit < stBit ) ffBit=stBit;
diff -ur inkscape-20040527/src/livarot/BitLigne.h inkscape-20040527_patched/src/livarot/BitLigne.h
--- inkscape-20040527/src/livarot/BitLigne.h	Fri May 28 13:45:09 2004
+++ inkscape-20040527_patched/src/livarot/BitLigne.h	Tue Jun  8 14:09:42 2004
@@ -12,7 +12,7 @@
 
 #include <stdio.h>
 #include <stdlib.h>
-#include <stdint.h>
+#include <inttypes.h>
 #include <string.h>
 
 #include "LivarotDefs.h"
diff -ur inkscape-20040527/src/livarot/DblLinked.h inkscape-20040527_patched/src/livarot/DblLinked.h
--- inkscape-20040527/src/livarot/DblLinked.h	Fri May 28 13:45:09 2004
+++ inkscape-20040527_patched/src/livarot/DblLinked.h	Mon Jun  7 20:05:47 2004
@@ -11,7 +11,7 @@
 
 #include <stdio.h>
 #include <stdlib.h>
-#include <stdint.h>
+#include <inttypes.h>
 #include <string.h>
 //#include <iostream.h>
 
diff -ur inkscape-20040527/src/livarot/Ligne.cpp inkscape-20040527_patched/src/livarot/Ligne.cpp
--- inkscape-20040527/src/livarot/Ligne.cpp	Fri May 28 13:45:09 2004
+++ inkscape-20040527_patched/src/livarot/Ligne.cpp	Mon Jun 14 11:14:29 2004
@@ -1739,7 +1739,7 @@
 	nbRun=0;
 	firstAc=lastAc=-1;
 	bool  pixExists=false;
-	int   curPos=(int)floorf(a->runs[0].st)-1;
+	int   curPos=(int)floor(a->runs[0].st)-1;
 	float lastSurf=0;
 	
   // we take each run of the FloatLigne in sequence and make single-pixel runs of its boundaries as needed
@@ -1748,8 +1748,8 @@
   // int_ligne_run, we just add the coverage to that run.
 	for (int i=0;i<a->nbRun;i++) {
 		float_ligne_run   runA=a->runs[i];
-		float curStF=floorf(runA.st);
-		float curEnF=floorf(runA.en);
+		float curStF=floor(runA.st);
+		float curEnF=floor(runA.en);
 		int  curSt=(int)curStF;
 		int  curEn=(int)curEnF;
 
diff -ur inkscape-20040527/src/livarot/Ligne.h inkscape-20040527_patched/src/livarot/Ligne.h
--- inkscape-20040527/src/livarot/Ligne.h	Fri May 28 13:45:09 2004
+++ inkscape-20040527_patched/src/livarot/Ligne.h	Mon Jun  7 20:13:17 2004
@@ -12,7 +12,7 @@
 
 #include <stdio.h>
 #include <stdlib.h>
-#include <stdint.h>
+#include <inttypes.h>
 #include <string.h>
 
 #include "LivarotDefs.h"
diff -ur inkscape-20040527/src/livarot/LivarotDefs.h inkscape-20040527_patched/src/livarot/LivarotDefs.h
--- inkscape-20040527/src/livarot/LivarotDefs.h	Fri May 28 13:45:09 2004
+++ inkscape-20040527_patched/src/livarot/LivarotDefs.h	Mon Jun  7 20:06:25 2004
@@ -8,7 +8,7 @@
 
 #ifndef my_defs
 #define my_defs
-#include <stdint.h>
+#include <inttypes.h>
 
 // error codes (mostly obsolete)
 enum
diff -ur inkscape-20040527/src/livarot/MyMath.h inkscape-20040527_patched/src/livarot/MyMath.h
--- inkscape-20040527/src/livarot/MyMath.h	Fri May 28 13:45:09 2004
+++ inkscape-20040527_patched/src/livarot/MyMath.h	Mon Jun 14 11:15:48 2004
@@ -11,7 +11,7 @@
 
 #include <stdio.h>
 #include <stdlib.h>
-#include <stdint.h>
+#include <inttypes.h>
 #include <string.h>
 //#include <iostream.h>
 
diff -ur inkscape-20040527/src/livarot/PathOutline.cpp inkscape-20040527_patched/src/livarot/PathOutline.cpp
--- inkscape-20040527/src/livarot/PathOutline.cpp	Fri May 28 13:45:09 2004
+++ inkscape-20040527_patched/src/livarot/PathOutline.cpp	Mon Jun 14 11:17:07 2004
@@ -863,8 +863,8 @@
 		path_descr_arcto* nData=(path_descr_arcto*)(ddata+curD->dStart);
 		if ( NR::LInfty(nData->p - curX) < 0.00001) {
 			if ((nData->large == false) 
-				|| (fabsf (nData->rx) < 0.00001
-					|| fabsf (nData->ry) < 0.00001)) {
+				|| (fabs (nData->rx) < 0.00001
+					|| fabs (nData->ry) < 0.00001)) {
 				return true;
 			}
 		}
@@ -1277,11 +1277,11 @@
 	double stGue = 1, miGue = 1, enGue = 1;
   // correction of the lengths of the tangent to the offset
   // if you don't see why i wrote that, draw a little figure and everything will be clear
-	if (fabsf (stRad) > 0.01)
+	if (fabs (stRad) > 0.01)
 		stGue += width / stRad;
-	if (fabsf (miRad) > 0.01)
+	if (fabs (miRad) > 0.01)
 		miGue += width / miRad;
-	if (fabsf (enRad) > 0.01)
+	if (fabs (enRad) > 0.01)
 		enGue += width / enRad;
 	stGue *= stTle;
 	miGue *= miTle;
@@ -1413,11 +1413,11 @@
 	}
   
 	double stGue = 1, miGue = 1, enGue = 1;
-	if (fabsf (stRad) > 0.01)
+	if (fabs (stRad) > 0.01)
 		stGue += width / stRad;
-	if (fabsf (miRad) > 0.01)
+	if (fabs (miRad) > 0.01)
 		miGue += width / miRad;
-	if (fabsf (enRad) > 0.01)
+	if (fabs (enRad) > 0.01)
 		enGue += width / enRad;
 	stGue *= stTle;
 	miGue *= miTle;
diff -ur inkscape-20040527/src/livarot/Shape.h inkscape-20040527_patched/src/livarot/Shape.h
--- inkscape-20040527/src/livarot/Shape.h	Fri May 28 13:45:09 2004
+++ inkscape-20040527_patched/src/livarot/Shape.h	Mon Jun  7 20:07:23 2004
@@ -12,7 +12,7 @@
 #include <math.h>
 #include <stdio.h>
 #include <stdlib.h>
-#include <stdint.h>
+#include <inttypes.h>
 #include <string.h>
 //#include <iostream.h>
 
diff -ur inkscape-20040527/src/livarot/ShapeMisc.cpp inkscape-20040527_patched/src/livarot/ShapeMisc.cpp
--- inkscape-20040527/src/livarot/ShapeMisc.cpp	Fri May 28 13:45:09 2004
+++ inkscape-20040527_patched/src/livarot/ShapeMisc.cpp	Mon Jun 14 11:21:03 2004
@@ -755,7 +755,7 @@
                 int  swai=prevEdge;prevEdge=nextEdge;nextEdge=swai;
               }
               if ( ebData[prevEdge].pieceID == ebData[nextEdge].pieceID  && ebData[prevEdge].pathID == ebData[nextEdge].pathID ) {
-                if ( fabsf(ebData[prevEdge].tEn-ebData[nextEdge].tSt) < 0.05 ) {
+                if ( fabs(ebData[prevEdge].tEn-ebData[nextEdge].tSt) < 0.05 ) {
                 } else {
                   dest->ForcePoint ();
                 }
diff -ur inkscape-20040527/src/livarot/ShapeUtils.h inkscape-20040527_patched/src/livarot/ShapeUtils.h
--- inkscape-20040527/src/livarot/ShapeUtils.h	Fri May 28 13:45:09 2004
+++ inkscape-20040527_patched/src/livarot/ShapeUtils.h	Mon Jun  7 20:07:46 2004
@@ -11,7 +11,7 @@
 
 #include <stdio.h>
 #include <stdlib.h>
-#include <stdint.h>
+#include <inttypes.h>
 #include <string.h>
 //#include <iostream.h>
 
diff -ur inkscape-20040527/src/object-edit.cpp inkscape-20040527_patched/src/object-edit.cpp
--- inkscape-20040527/src/object-edit.cpp	Fri May 28 13:45:10 2004
+++ inkscape-20040527_patched/src/object-edit.cpp	Mon Jun  7 20:02:12 2004
@@ -356,7 +356,7 @@
 	     && ( snaps != 0 ) )
 	{
 		gdouble arg = 2.0*M_PI*spiral->revo*spiral->t0 + spiral->arg;
-		spiral->t0 = (round(arg/(M_PI/snaps))*(M_PI/snaps) - spiral->arg)/(2.0*M_PI*spiral->revo);
+		spiral->t0 = (rint(arg/(M_PI/snaps))*(M_PI/snaps) - spiral->arg)/(2.0*M_PI*spiral->revo);
 	}
 
 	spiral->t0 = CLAMP (spiral->t0, 0.0, 0.999);
@@ -386,7 +386,7 @@
 
 	if ( ( state & GDK_CONTROL_MASK )
 	     && snaps ) {
-		spiral->arg = round (spiral->arg/(M_PI/snaps))*(M_PI/snaps);
+		spiral->arg = rint (spiral->arg/(M_PI/snaps))*(M_PI/snaps);
 	}
 
 	sp_object_request_update ((SPObject *) spiral, SP_OBJECT_MODIFIED_FLAG);
diff -ur inkscape-20040527/src/sp-shape.cpp inkscape-20040527_patched/src/sp-shape.cpp
--- inkscape-20040527/src/sp-shape.cpp	Fri May 28 13:45:10 2004
+++ inkscape-20040527_patched/src/sp-shape.cpp	Mon Jun  7 20:11:52 2004
@@ -494,7 +494,7 @@
         SPStyle* style=SP_OBJECT_STYLE (item);
         if (style->stroke.type != SP_PAINT_TYPE_NONE) {
             double const scale = expansion(transform);
-            if ( fabsf(style->stroke_width.computed * scale) > 0.01 ) { // sinon c'est 0=oon veut pas de bord
+            if ( fabs(style->stroke_width.computed * scale) > 0.01 ) { // sinon c'est 0=oon veut pas de bord
                 double const width = MAX(0.125, style->stroke_width.computed * scale);
                 if ( fabs(cbbox.x1-cbbox.x0) > -0.00001 && fabs(cbbox.y1-cbbox.y0) > -0.00001 ) {
                     cbbox.x0-=0.5*width;
diff -ur inkscape-20040527/src/spiral-context.cpp inkscape-20040527_patched/src/spiral-context.cpp
--- inkscape-20040527/src/spiral-context.cpp	Fri May 28 13:45:12 2004
+++ inkscape-20040527_patched/src/spiral-context.cpp	Mon Jun  7 20:04:38 2004
@@ -419,7 +419,7 @@
 	gdouble arg = NR::atan2 (delta) - 2.0*M_PI*spiral->revo;
 
   	if (state & GDK_CONTROL_MASK) { 
-		arg = round (arg/(M_PI/snaps))*(M_PI/snaps);
+		arg = rint (arg/(M_PI/snaps))*(M_PI/snaps);
 	} 
 	
         /* Fixme: these parameters should be got from dialog box */
diff -ur inkscape-20040527/src/star-context.cpp inkscape-20040527_patched/src/star-context.cpp
--- inkscape-20040527/src/star-context.cpp	Fri May 28 13:45:10 2004
+++ inkscape-20040527_patched/src/star-context.cpp	Tue Jun  8 14:03:37 2004
@@ -451,7 +451,7 @@
     gdouble r1 = NR::L2 (d);
     gdouble arg1 = atan2 (d);
     if (state & GDK_CONTROL_MASK) {
-        arg1 = ( round( arg1 / (M_PI/snaps) )
+        arg1 = ( rint( arg1 / (M_PI/snaps) )
                  * (M_PI/snaps) );
     }
     bool isflat = sc->isflatsided;