# Bazaar merge directive format 2 (Bazaar 0.90)
# revision_id: cr33dog@gmail.com-20120528204732-833fo9bh2nolj5uk
# target_branch: http://bazaar.launchpad.net/~inkscape.dev/inkscape\
#   /trunk/
# testament_sha1: 9d8c6bbc3810212f1b41695a10511ee05ce53e67
# timestamp: 2012-05-28 15:47:40 -0500
# base_revision_id: j.b.c.engelen@alumnus.utwente.nl-20120528185600-\
#   ywyarb2b08jw1v68
# 
# Begin patch
=== modified file 'src/extension/internal/pdfinput/pdf-parser.cpp'
--- src/extension/internal/pdfinput/pdf-parser.cpp	2012-05-15 01:22:42 +0000
+++ src/extension/internal/pdfinput/pdf-parser.cpp	2012-05-28 20:47:32 +0000
@@ -11,6 +11,8 @@
  *
  */
 
+#define POPPLER_NEW_COLOR_SPACE_API 1
+
 #ifdef HAVE_CONFIG_H
 # include <config.h>
 #endif
@@ -368,14 +370,14 @@
     for (int i = 0; i < obj->arrayGetLength(); ++i) {
       obj->arrayGet(i, &obj2);
       if (!obj2.isStream()) {
-	error(-1, const_cast<char*>("Weird page contents"));
+	error(errInternal, -1, const_cast<char*>("Weird page contents"));
 	obj2.free();
 	return;
       }
       obj2.free();
     }
   } else if (!obj->isStream()) {
-    error(-1, const_cast<char*>("Weird page contents"));
+    error(errInternal, -1, const_cast<char*>("Weird page contents"));
     return;
   }
   parser = new Parser(xref, new Lexer(xref, obj), gFalse);
@@ -420,7 +422,7 @@
 
     // too many arguments - something is wrong
     } else {
-      error(getPos(), const_cast<char*>("Too many args in content stream"));
+      error(errInternal, getPos(), const_cast<char*>("Too many args in content stream"));
       if (printCommands) {
 	printf("throwing away arg: ");
 	obj.print(stdout);
@@ -437,7 +439,7 @@
 
   // args at end with no command
   if (numArgs > 0) {
-    error(getPos(), const_cast<char*>("Leftover args in content stream"));
+    error(errInternal, getPos(), const_cast<char*>("Leftover args in content stream"));
     if (printCommands) {
       printf("%d leftovers:", numArgs);
       for (int i = 0; i < numArgs; ++i) {
@@ -503,7 +505,7 @@
   name = cmd->getCmd();
   if (!(op = findOp(name))) {
     if (ignoreUndef == 0)
-      error(getPos(), const_cast<char*>("Unknown operator '%s'"), name);
+      error(errInternal, getPos(), const_cast<char*>("Unknown operator '%s'"), name);
     return;
   }
 
@@ -511,26 +513,26 @@
   argPtr = args;
   if (op->numArgs >= 0) {
     if (numArgs < op->numArgs) {
-      error(getPos(), const_cast<char*>("Too few (%d) args to '%s' operator"), numArgs, name);
+      error(errInternal, getPos(), const_cast<char*>("Too few (%d) args to '%s' operator"), numArgs, name);
       return;
     }
     if (numArgs > op->numArgs) {
 #if 0
-      error(getPos(), "Too many (%d) args to '%s' operator", numArgs, name);
+      error(errInternal, getPos(), "Too many (%d) args to '%s' operator", numArgs, name);
 #endif
       argPtr += numArgs - op->numArgs;
       numArgs = op->numArgs;
     }
   } else {
     if (numArgs > -op->numArgs) {
-      error(getPos(), const_cast<char*>("Too many (%d) args to '%s' operator"),
+      error(errInternal, getPos(), const_cast<char*>("Too many (%d) args to '%s' operator"),
 	    numArgs, name);
       return;
     }
   }
   for (i = 0; i < numArgs; ++i) {
     if (!checkArg(&argPtr[i], op->tchk[i])) {
-      error(getPos(), const_cast<char*>("Arg #%d to '%s' operator is wrong type (%s)"),
+      error(errInternal, getPos(), const_cast<char*>("Arg #%d to '%s' operator is wrong type (%s)"),
 	    i, name, argPtr[i].getTypeName());
       return;
     }
@@ -703,7 +705,7 @@
     return;
   }
   if (!obj1.isDict()) {
-    error(getPos(), const_cast<char*>("ExtGState '%s' is wrong type"), args[0].getName());
+    error(errInternal, getPos(), const_cast<char*>("ExtGState '%s' is wrong type"), args[0].getName());
     obj1.free();
     return;
   }
@@ -719,7 +721,7 @@
     if (state->parseBlendMode(&obj2, &mode)) {
       state->setBlendMode(mode);
     } else {
-      error(getPos(), const_cast<char*>("Invalid blend mode in ExtGState"));
+      error(errInternal, getPos(), const_cast<char*>("Invalid blend mode in ExtGState"));
     }
   }
   obj2.free();
@@ -781,7 +783,7 @@
       state->setTransfer(funcs);
     }
   } else if (!obj2.isNull()) {
-    error(getPos(), const_cast<char*>("Invalid transfer function in ExtGState"));
+    error(errInternal, getPos(), const_cast<char*>("Invalid transfer function in ExtGState"));
   }
   obj2.free();
 
@@ -801,7 +803,7 @@
 	funcs[0] = Function::parse(&obj3);
 	if (funcs[0]->getInputSize() != 1 ||
 	    funcs[0]->getOutputSize() != 1) {
-	  error(getPos(),
+	  error(errInternal, getPos(),
 		const_cast<char*>("Invalid transfer function in soft mask in ExtGState"));
 	  delete funcs[0];
 	  funcs[0] = NULL;
@@ -858,15 +860,15 @@
 	    delete funcs[0];
 	  }
 	} else {
-	  error(getPos(), const_cast<char*>("Invalid soft mask in ExtGState - missing group"));
+	  error(errInternal, getPos(), const_cast<char*>("Invalid soft mask in ExtGState - missing group"));
 	}
 	obj4.free();
       } else {
-	error(getPos(), const_cast<char*>("Invalid soft mask in ExtGState - missing group"));
+	error(errInternal, getPos(), const_cast<char*>("Invalid soft mask in ExtGState - missing group"));
       }
       obj3.free();
     } else if (!obj2.isNull()) {
-      error(getPos(), const_cast<char*>("Invalid soft mask in ExtGState"));
+      error(errInternal, getPos(), const_cast<char*>("Invalid soft mask in ExtGState"));
     }
   }
   obj2.free();
@@ -894,7 +896,7 @@
   // check form type
   dict->lookup(const_cast<char*>("FormType"), &obj1);
   if (!(obj1.isNull() || (obj1.isInt() && obj1.getInt() == 1))) {
-    error(getPos(), const_cast<char*>("Unknown form type"));
+    error(errInternal, getPos(), const_cast<char*>("Unknown form type"));
   }
   obj1.free();
 
@@ -902,7 +904,7 @@
   dict->lookup(const_cast<char*>("BBox"), &obj1);
   if (!obj1.isArray()) {
     obj1.free();
-    error(getPos(), const_cast<char*>("Bad form bounding box"));
+    error(errInternal, getPos(), const_cast<char*>("Bad form bounding box"));
     return;
   }
   for (i = 0; i < 4; ++i) {
@@ -1062,7 +1064,7 @@
     state->setFillColor(&color);
     builder->updateStyle(state);
   } else {
-    error(getPos(), const_cast<char*>("Bad color space (fill)"));
+    error(errInternal, getPos(), const_cast<char*>("Bad color space (fill)"));
   }
 }
 
@@ -1095,7 +1097,7 @@
     state->setStrokeColor(&color);
     builder->updateStyle(state);
   } else {
-    error(getPos(), const_cast<char*>("Bad color space (stroke)"));
+    error(errInternal, getPos(), const_cast<char*>("Bad color space (stroke)"));
   }
 }
 
@@ -1104,7 +1106,7 @@
   int i;
 
   if (numArgs != state->getFillColorSpace()->getNComps()) {
-    error(getPos(), const_cast<char*>("Incorrect number of arguments in 'sc' command"));
+    error(errInternal, getPos(), const_cast<char*>("Incorrect number of arguments in 'sc' command"));
     return;
   }
   state->setFillPattern(NULL);
@@ -1120,7 +1122,7 @@
   int i;
 
   if (numArgs != state->getStrokeColorSpace()->getNComps()) {
-    error(getPos(), const_cast<char*>("Incorrect number of arguments in 'SC' command"));
+    error(errInternal, getPos(), const_cast<char*>("Incorrect number of arguments in 'SC' command"));
     return;
   }
   state->setStrokePattern(NULL);
@@ -1141,7 +1143,7 @@
       if (!((GfxPatternColorSpace *)state->getFillColorSpace())->getUnder() ||
 	  numArgs - 1 != ((GfxPatternColorSpace *)state->getFillColorSpace())
 	                     ->getUnder()->getNComps()) {
-	error(getPos(), const_cast<char*>("Incorrect number of arguments in 'scn' command"));
+	error(errInternal, getPos(), const_cast<char*>("Incorrect number of arguments in 'scn' command"));
 	return;
       }
       for (i = 0; i < numArgs - 1 && i < gfxColorMaxComps; ++i) {
@@ -1168,7 +1170,7 @@
 
   } else {
     if (numArgs != state->getFillColorSpace()->getNComps()) {
-      error(getPos(), const_cast<char*>("Incorrect number of arguments in 'scn' command"));
+      error(errInternal, getPos(), const_cast<char*>("Incorrect number of arguments in 'scn' command"));
       return;
     }
     state->setFillPattern(NULL);
@@ -1193,7 +1195,7 @@
 	       ->getUnder() ||
 	  numArgs - 1 != ((GfxPatternColorSpace *)state->getStrokeColorSpace())
 	                     ->getUnder()->getNComps()) {
-	error(getPos(), const_cast<char*>("Incorrect number of arguments in 'SCN' command"));
+	error(errInternal, getPos(), const_cast<char*>("Incorrect number of arguments in 'SCN' command"));
 	return;
       }
       for (i = 0; i < numArgs - 1 && i < gfxColorMaxComps; ++i) {
@@ -1220,7 +1222,7 @@
 
   } else {
     if (numArgs != state->getStrokeColorSpace()->getNComps()) {
-      error(getPos(), const_cast<char*>("Incorrect number of arguments in 'SCN' command"));
+      error(errInternal, getPos(), const_cast<char*>("Incorrect number of arguments in 'SCN' command"));
       return;
     }
     state->setStrokePattern(NULL);
@@ -1248,7 +1250,7 @@
 void PdfParser::opLineTo(Object args[], int /*numArgs*/)
 {
   if (!state->isCurPt()) {
-    error(getPos(), const_cast<char*>("No current point in lineto"));
+    error(errInternal, getPos(), const_cast<char*>("No current point in lineto"));
     return;
   }
   state->lineTo(args[0].getNum(), args[1].getNum());
@@ -1258,7 +1260,7 @@
 void PdfParser::opCurveTo(Object args[], int /*numArgs*/)
 {
   if (!state->isCurPt()) {
-    error(getPos(), const_cast<char*>("No current point in curveto"));
+    error(errInternal, getPos(), const_cast<char*>("No current point in curveto"));
     return;
   }
   double x1 = args[0].getNum();
@@ -1274,7 +1276,7 @@
 void PdfParser::opCurveTo1(Object args[], int /*numArgs*/)
 {
   if (!state->isCurPt()) {
-    error(getPos(), const_cast<char*>("No current point in curveto1"));
+    error(errInternal, getPos(), const_cast<char*>("No current point in curveto1"));
     return;
   }
   double x1 = state->getCurX();
@@ -1290,7 +1292,7 @@
 void PdfParser::opCurveTo2(Object args[], int /*numArgs*/)
 {
   if (!state->isCurPt()) {
-    error(getPos(), const_cast<char*>("No current point in curveto2"));
+    error(errInternal, getPos(), const_cast<char*>("No current point in curveto2"));
     return;
   }
   double x1 = args[0].getNum();
@@ -1319,7 +1321,7 @@
 void PdfParser::opClosePath(Object /*args*/[], int /*numArgs*/)
 {
   if (!state->isCurPt()) {
-    error(getPos(), const_cast<char*>("No current point in closepath"));
+    error(errInternal, getPos(), const_cast<char*>("No current point in closepath"));
     return;
   }
   state->closePath();
@@ -1337,7 +1339,7 @@
 void PdfParser::opStroke(Object /*args*/[], int /*numArgs*/)
 {
   if (!state->isCurPt()) {
-    //error(getPos(), const_cast<char*>("No path in stroke"));
+    //error(errInternal, getPos(), const_cast<char*>("No path in stroke"));
     return;
   }
   if (state->isPath()) {
@@ -1353,7 +1355,7 @@
 
 void PdfParser::opCloseStroke(Object * /*args[]*/, int /*numArgs*/) {
   if (!state->isCurPt()) {
-    //error(getPos(), const_cast<char*>("No path in closepath/stroke"));
+    //error(errInternal, getPos(), const_cast<char*>("No path in closepath/stroke"));
     return;
   }
   state->closePath();
@@ -1371,7 +1373,7 @@
 void PdfParser::opFill(Object /*args*/[], int /*numArgs*/)
 {
   if (!state->isCurPt()) {
-    //error(getPos(), const_cast<char*>("No path in fill"));
+    //error(errInternal, getPos(), const_cast<char*>("No path in fill"));
     return;
   }
   if (state->isPath()) {
@@ -1388,7 +1390,7 @@
 void PdfParser::opEOFill(Object /*args*/[], int /*numArgs*/)
 {
   if (!state->isCurPt()) {
-    //error(getPos(), const_cast<char*>("No path in eofill"));
+    //error(errInternal, getPos(), const_cast<char*>("No path in eofill"));
     return;
   }
   if (state->isPath()) {
@@ -1405,7 +1407,7 @@
 void PdfParser::opFillStroke(Object /*args*/[], int /*numArgs*/)
 {
   if (!state->isCurPt()) {
-    //error(getPos(), const_cast<char*>("No path in fill/stroke"));
+    //error(errInternal, getPos(), const_cast<char*>("No path in fill/stroke"));
     return;
   }
   if (state->isPath()) {
@@ -1419,7 +1421,7 @@
 void PdfParser::opCloseFillStroke(Object /*args*/[], int /*numArgs*/)
 {
   if (!state->isCurPt()) {
-    //error(getPos(), const_cast<char*>("No path in closepath/fill/stroke"));
+    //error(errInternal, getPos(), const_cast<char*>("No path in closepath/fill/stroke"));
     return;
   }
   if (state->isPath()) {
@@ -1432,7 +1434,7 @@
 void PdfParser::opEOFillStroke(Object /*args*/[], int /*numArgs*/)
 {
   if (!state->isCurPt()) {
-    //error(getPos(), const_cast<char*>("No path in eofill/stroke"));
+    //error(errInternal, getPos(), const_cast<char*>("No path in eofill/stroke"));
     return;
   }
   if (state->isPath()) {
@@ -1444,7 +1446,7 @@
 void PdfParser::opCloseEOFillStroke(Object /*args*/[], int /*numArgs*/)
 {
   if (!state->isCurPt()) {
-    //error(getPos(), const_cast<char*>("No path in closepath/eofill/stroke"));
+    //error(errInternal, getPos(), const_cast<char*>("No path in closepath/eofill/stroke"));
     return;
   }
   if (state->isPath()) {
@@ -1485,7 +1487,7 @@
     doShadingPatternFillFallback(static_cast<GfxShadingPattern *>(pattern), gFalse, eoFill);
     break;
   default:
-    error(getPos(), const_cast<char*>("Unimplemented pattern type (%d) in fill"),
+    error(errInternal, getPos(), const_cast<char*>("Unimplemented pattern type (%d) in fill"),
 	  pattern->getType());
     break;
   }
@@ -1504,7 +1506,7 @@
     doShadingPatternFillFallback(static_cast<GfxShadingPattern *>(pattern), gTrue, gFalse);
     break;
   default:
-    error(getPos(), const_cast<char*>("Unimplemented pattern type (%d) in stroke"),
+    error(errInternal, getPos(), const_cast<char*>("Unimplemented pattern type (%d) in stroke"),
 	  pattern->getType());
     break;
   }
@@ -2247,7 +2249,7 @@
 void PdfParser::opShowText(Object args[], int /*numArgs*/)
 {
   if (!state->getFont()) {
-    error(getPos(), const_cast<char*>("No font in show"));
+    error(errInternal, getPos(), const_cast<char*>("No font in show"));
     return;
   }
   if (fontChanged) {
@@ -2264,7 +2266,7 @@
   double ty = 0;
 
   if (!state->getFont()) {
-    error(getPos(), const_cast<char*>("No font in move/show"));
+    error(errInternal, getPos(), const_cast<char*>("No font in move/show"));
     return;
   }
   if (fontChanged) {
@@ -2285,7 +2287,7 @@
   double ty = 0;
 
   if (!state->getFont()) {
-    error(getPos(), const_cast<char*>("No font in move/set/show"));
+    error(errInternal, getPos(), const_cast<char*>("No font in move/set/show"));
     return;
   }
   if (fontChanged) {
@@ -2309,7 +2311,7 @@
   int wMode = 0;
 
   if (!state->getFont()) {
-    error(getPos(), const_cast<char*>("No font in show/space"));
+    error(errInternal, getPos(), const_cast<char*>("No font in show/space"));
     return;
   }
   if (fontChanged) {
@@ -2334,7 +2336,7 @@
     } else if (obj.isString()) {
       doShowText(obj.getString());
     } else {
-      error(getPos(), const_cast<char*>("Element of show/space array must be number or string"));
+      error(errInternal, getPos(), const_cast<char*>("Element of show/space array must be number or string"));
     }
     obj.free();
   }
@@ -2432,7 +2434,7 @@
 	if (charProc.isStream()) {
 	  //parse(&charProc, gFalse); // TODO: parse into SVG font
 	} else {
-	  error(getPos(), const_cast<char*>("Missing or bad Type3 CharProc entry"));
+	  error(errInternal, getPos(), const_cast<char*>("Missing or bad Type3 CharProc entry"));
 	}
 	//out->endType3Char(state);
 	if (resDict) {
@@ -2509,7 +2511,7 @@
     return;
   }
   if (!obj1.isStream()) {
-    error(getPos(), const_cast<char*>("XObject '%s' is wrong type"), name);
+    error(errInternal, getPos(), const_cast<char*>("XObject '%s' is wrong type"), name);
     obj1.free();
     return;
   }
@@ -2525,9 +2527,9 @@
 /*    out->psXObject(obj1.getStream(),
     		   obj3.isStream() ? obj3.getStream() : (Stream *)NULL);*/
   } else if (obj2.isName()) {
-    error(getPos(), const_cast<char*>("Unknown XObject subtype '%s'"), obj2.getName());
+    error(errInternal, getPos(), const_cast<char*>("Unknown XObject subtype '%s'"), obj2.getName());
   } else {
-    error(getPos(), const_cast<char*>("XObject subtype is missing or wrong type"));
+    error(errInternal, getPos(), const_cast<char*>("XObject subtype is missing or wrong type"));
   }
   obj2.free();
   obj1.free();
@@ -2858,7 +2860,7 @@
  err2:
   obj1.free();
  err1:
-  error(getPos(), const_cast<char*>("Bad image parameters"));
+  error(errInternal, getPos(), const_cast<char*>("Bad image parameters"));
 }
 
 void PdfParser::doForm(Object *str) {
@@ -2883,7 +2885,7 @@
   // check form type
   dict->lookup(const_cast<char*>("FormType"), &obj1);
   if (!(obj1.isNull() || (obj1.isInt() && obj1.getInt() == 1))) {
-    error(getPos(), const_cast<char*>("Unknown form type"));
+    error(errInternal, getPos(), const_cast<char*>("Unknown form type"));
   }
   obj1.free();
 
@@ -2891,7 +2893,7 @@
   dict->lookup(const_cast<char*>("BBox"), &bboxObj);
   if (!bboxObj.isArray()) {
     bboxObj.free();
-    error(getPos(), const_cast<char*>("Bad form bounding box"));
+    error(errInternal, getPos(), const_cast<char*>("Bad form bounding box"));
     return;
   }
   for (i = 0; i < 4; ++i) {
@@ -3088,7 +3090,7 @@
   parser->getObj(&obj);
   while (!obj.isCmd(const_cast<char*>("ID")) && !obj.isEOF()) {
     if (!obj.isName()) {
-      error(getPos(), const_cast<char*>("Inline image dictionary key must be a name object"));
+      error(errInternal, getPos(), const_cast<char*>("Inline image dictionary key must be a name object"));
       obj.free();
     } else {
       key = copyString(obj.getName());
@@ -3103,7 +3105,7 @@
     parser->getObj(&obj);
   }
   if (obj.isEOF()) {
-    error(getPos(), const_cast<char*>("End of file in inline image"));
+    error(errInternal, getPos(), const_cast<char*>("End of file in inline image"));
     obj.free();
     dict.free();
     return NULL;
@@ -3119,12 +3121,12 @@
 
 void PdfParser::opImageData(Object /*args*/[], int /*numArgs*/)
 {
-  error(getPos(), const_cast<char*>("Internal: got 'ID' operator"));
+  error(errInternal, getPos(), const_cast<char*>("Internal: got 'ID' operator"));
 }
 
 void PdfParser::opEndImage(Object /*args*/[], int /*numArgs*/)
 {
-  error(getPos(), const_cast<char*>("Internal: got 'EI' operator"));
+  error(errInternal, getPos(), const_cast<char*>("Internal: got 'EI' operator"));
 }
 
 //------------------------------------------------------------------------

=== modified file 'src/extension/internal/pdfinput/svg-builder.cpp'
--- src/extension/internal/pdfinput/svg-builder.cpp	2012-05-18 07:54:13 +0000
+++ src/extension/internal/pdfinput/svg-builder.cpp	2012-05-28 20:47:32 +0000
@@ -1004,9 +1004,7 @@
     _font_style = sp_repr_css_attr_new();
     GfxFont *font = state->getFont();
     // Store original name
-    if (font->getOrigName()) {
-        _font_specification = font->getOrigName()->getCString();
-    } else if (font->getName()) {
+    if (font->getName()) {
         _font_specification = font->getName()->getCString();
     } else {
         _font_specification = (char*) "Arial";

# Begin bundle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